/*************************************************************************/
/*									 */
/*		Definitions used in C4.5				 */
/*              ------------------------				 */
/*									 */
/*************************************************************************/


#include <stdio.h>
#include <math.h>
#include <stdlib.h>   /* Needed for atof() on Linux */

#define	 None			-1
#define	 Epsilon                1E-3f

#define  SMALL			1E-6f

#define	 Random			((random()&2147483647) / 2147483648.0)

#define	 Max(a,b)               ((a)>(b) ? a : b) 
#define	 Min(a,b)               ((a)<(b) ? a : b) 
#define	 Round(x)		((int) (x+0.5))
/* All Log stuff was moved to log.c, as an inline function */
inline float Log(double d);

#define	 Bit(b)			(1 << (b))
#define	 In(b,s)		((s[(b) >> 3]) & Bit((b) & 07))
#define	 ClearBits(n,s)		memset(s,0,n)
#define	 CopyBits(n,f,t)	memcpy(t,f,n)
#define	 SetBit(b,s)		(s[(b) >> 3] |= Bit((b) & 07))

#define	 ForEach(v,f,l)		for(v=f ; v<=l ; ++v) 

#define	 Verbosity(d)		if(VERBOSITY >= d)


#define TRAIN_DATA      0
#define TEST_DATA       1
#define VALIDATION_DATA 2
#define BAGGED_DATA     3
#define BOOSTED_DATA	4


#define load_training_data()    (init_data(TRAIN_DATA))
#define load_test_data()        (init_data(TEST_DATA))
#define load_validation_data()  (init_data(VALIDATION_DATA))
#define load_bagged_data()      (init_data(BAGGED_DATA))
#define load_boosted_data()	(init_data(BOOSTED_DATA))
