#include "globals.h"

int FindLeaf(struct tree_node * t, int dataset, int testid);
int FindClassNdx(struct tree_node * t, int dataset, int testid);

void evaluate(int dataset)
{
  int i;
  char filename[MAXLINE];
  FILE *cfp, *lfp;

  if(OUTPUT_LEAFS==1) {
    bzero(filename,MAXLINE);
    sprintf(filename,"%s.test_leafs", filestem);
    lfp=fopen(filename,"w");
  }

  bzero(filename,MAXLINE);
  sprintf(filename,"%s.test_pred", filestem);
  cfp=fopen(filename,"w");

  for(i=0;i<num_test;i++)
    {
      if(OUTPUT_LEAFS==1)
	fprintf(lfp,"%d\n",FindLeaf(tree_root, TEST, i));
      fprintf(cfp,"%s\n",classes_list[FindClassNdx(tree_root, TEST, i)]);
    }
  if(OUTPUT_LEAFS==1) {
     fclose(lfp);
  }
  if(OUTPUT_LEAFS==1) {
    bzero(filename,MAXLINE);
    sprintf(filename,"%s.train_leafs", filestem);
    lfp=fopen(filename,"w");
    for(i=0;i<num_train;i++)
      {
	fprintf(lfp,"%d\n",FindLeaf(tree_root, DATA, i));
      }
    fclose(lfp);
  }
  fclose(cfp);
}

void print_class(int dataset)
{
  int i;
  char filename[MAXLINE];
  FILE *cfp;

  bzero(filename,MAXLINE);
  sprintf(filename,"%s.test_class", filestem);
  cfp=fopen(filename,"w");

  for(i=0;i<num_test;i++)
    {
      fprintf(cfp,"%s\n",classes_list[test_class_list[i]]);
    }

  fclose(cfp);
  bzero(filename,MAXLINE);
  sprintf(filename,"%s.train_class", filestem);
  cfp=fopen(filename,"w");
  for(i=0;i<num_train;i++)
    {
      fprintf(cfp,"%s\n",classes_list[train_class_list[i]]);
    }

  fclose(cfp);
}

int FindLeaf(struct tree_node * t, int dataset, int testid)
{
  if(t->leaf==1) {
    return t->nodeid;
  }
  else {
    if(attr_types[t->attribute]==CONTINUOUS) {
      if(dataset==DATA) {
	if(train_continuous_list[testid][t->attribute] <= t->split_val)  {
	  return FindLeaf(t->children[0], dataset, testid);
	}
	else {
	  return FindLeaf(t->children[1], dataset, testid);
	}
      }
      else if (dataset==TEST) {
	if(test_continuous_list[testid][t->attribute] <= t->split_val)  {
	  return FindLeaf(t->children[0], dataset, testid);
	}
	else {
	  return FindLeaf(t->children[1], dataset, testid);
	}
      }
    }
    else { //NOMINAL 
      if(dataset==DATA) {
	return FindLeaf(t->children[train_attr_list[testid][t->attribute]], dataset, testid);
      }
      else if (dataset==TEST) {
	return FindLeaf(t->children[test_attr_list[testid][t->attribute]], dataset, testid);
      }
    }
  }
}

int FindClassNdx(struct tree_node * t, int dataset, int testid)
{
  if(t->leaf==1)
    {
      return t->class;
    }
  else
    {
      if(attr_types[t->attribute]==CONTINUOUS)
	{
	  if(test_continuous_list[testid][t->attribute] <= t->split_val)
	    {
	      return FindClassNdx(t->children[0], dataset, testid);
	    }
	  else
	    {
	      return FindClassNdx(t->children[1], dataset, testid);
	    }
	}
      else //NOMINAL
	{
	  return FindClassNdx(t->children[test_attr_list[testid][t->attribute]], dataset, testid);
	}
    }
}
