#include "hash.h"

void init(struct node * t)
{
  if(t!=NULL)
    {
      //printf("this?\n");
      delete_hash(t);
      //free(t);
    }
  //printf("these?\n");
  //new_index=0;
  t=NULL;
}

int height(node *t)  
{
  return t == NULL ? -1 : t->height;
}

int max_func(int a, int b)
{
  if(a>b)
    {
      return a;
    }
  else
    {
      return b;
    }
}

void insert_hash_i(struct node ** t, int value, int index)
{
  char * temp = malloc(MAXLINE*sizeof(char));
  bzero(temp,MAXLINE);
  sprintf(temp, "%d", value);
  insert_hash(t, temp, index);
}

void insert_hash(struct node ** t, char * value, int index)
{
  struct node * new_node = malloc(sizeof(struct node));
  new_node->value=strdup(value);
  new_node->index=index;
  new_node->left=NULL;
  new_node->right=NULL;
  new_node->height=0;
  AVL_insert(&(*t),new_node);
}

void delete_hash(node *t)
{
  delete_AVL(t);
}

void delete_AVL(node *t)
{
  if(t->left!=NULL)
    {
      delete_AVL(t->left);
    }
  if(t->right!=NULL)
    {
      delete_AVL(t->right);
    }
  free(t);
}

node * AVL_rotate_left_child(node *t)
{
  node * x;
  x=t->left;
  t->left=x->right;
  x->right=t;
  t->height=max_func(height(t->left),height(t->right))+1;
  x->height=max_func(height(x->left),t->height)+1;
  return x;
}

node * AVL_rotate_right_child(node *t)
{

  node * x;
  x=t->right;
  t->right=x->left;
  x->left=t;
  t->height=max_func(height(t->left),height(t->right))+1;
  x->height=max_func(height(x->right),t->height)+1;
  return x;
}

node * AVL_double_left_child(node *t)
{
  t->left=AVL_rotate_right_child(t->left);
  return AVL_rotate_left_child(t);
}

node * AVL_double_right_child(node *t)
{
  t->right=AVL_rotate_left_child(t->right);
  return AVL_rotate_right_child(t);
}

void AVL_insert(struct node **t, struct node *x)
{
  if(*t==NULL)
    {
      *t=x;
    }
  else if(strcmp(x->value,(*t)->value) < 0)
    {
      AVL_insert(&(*t)->left,x);
      if(height((*t)->left)-height((*t)->right)==2)
	{

	  if(strcmp(x->value,(*t)->value) < 0)
	    {
	      *t=AVL_rotate_left_child(*t); // Case 1
	    }
	  else
	    {
	      *t=AVL_double_left_child(*t); // Case 2
	    }

	}
    }
  else
    {
      AVL_insert(&(*t)->right,x);
    }
  (*t)->height=max_func(height((*t)->left),height((*t)->right))+1;
}

int hash_i(struct node * t, int value)
{
  char * temp = malloc(MAXLINE*sizeof(char));
  bzero(temp,MAXLINE);
  sprintf(temp, "%d", value);
  return hash(t, temp);
}

int hash(struct node *t, char * value)
{
  struct node * curr;
  curr = t;

  while(1)
    {
      if( curr==NULL )
	{
	  return -1;
	}
      if( strcmp(curr->value,value) == 0 )
	{
	  return curr->index;
	}
      else if( strcmp(curr->value,value) > 0 )
	{
	  if(curr->left!=NULL)
	    {
	      curr=curr->left;
	    }
	  else
	    {
	      return -1;
	    }
	}
      else if( strcmp(curr->value,value) < 0 )
	{
	  if(curr->right!=NULL)
	    {
	      curr=curr->right;
	    }
	  else
	    {
	      return -1;
	    }
	}
    }
}

