#ifndef HASH_H
#define HASH_H

//#include <iostream>
#include <stdio.h>
#include <stdlib.h>

#define MAXLINE 1024

/*
 *AVL nodes need to track heights of right and left
 *subtrees
 */
typedef struct node {
  int value;
  int index;
  struct node * left;
  struct node * right;
  int height;
} node;

void init(struct node *);
int height(struct node *);
int max_func(int, int);
node * AVL_rotate_left_child(node *);
node * AVL_rotate_right_child(node *);
node * AVL_double_left_child(node *);
node * AVL_double_right_child(node *);
void AVL_insert(node **, node *);
void delete_AVL(node *t);

void insert_hash(struct node **, char *, int);
void insert_hash_i(struct node **, int, int);
void delete_hash(struct node *);
int hash(struct node*, char *);
int hash_i(struct node*, int);
#endif
