#include <wx/wx.h>
#include <wx/progdlg.h>
#include <stdarg.h>
#include "util_log.h"

static wxProgressDialog **progress_bars=NULL;
static int num_progress_bars=0;

void pb_update(int, int, char *,...);
void pb_finish(int);

int pb_create(int max, char *title,...)
{
  char buf[1024];
  
  /* Handle the optional printf-like arguments */
	va_list ap;
  va_start(ap,title);
  vsprintf(buf,title,ap);
  /* Create the progress bar */
	progress_bars=(wxProgressDialog **)realloc(progress_bars,(num_progress_bars+1)*sizeof(wxProgressDialog *));
	progress_bars[num_progress_bars]=new wxProgressDialog(buf,"",max);
	num_progress_bars++;
	
	return num_progress_bars-1;
}

void pb_update(int pb, int value, char *msg,...)
{
  char buf[1024];
  
	if ( pb >= 0 && pb < num_progress_bars ) {
	  /* Handle the optional printf-like arguments */
		va_list ap;
	  va_start(ap,msg);
  	vsprintf(buf,msg,ap);


		progress_bars[pb]->Update(value,buf);
	}
}

void pb_finish(int pb) 
{
	int i;
	if ( pb >= 0 && pb < num_progress_bars) {
		for (i=num_progress_bars-1; i >= pb; i--)
			delete(progress_bars[i]);
			
		num_progress_bars=pb;
		if ( pb == 0 ) {
			free(progress_bars);
			progress_bars=NULL;
		}
	}
}
