/*
  Trim a string of whitespace from both ends.
*/
#include <strings.h>
#include <ctype.h>


/* Trim leading spaces (whitespace) */
inline char *ltrim(char *start)
{
  if ( !start ) return start;
  for (; *start != 0 && isspace((int)(*start)); start++);
  return start;
}

/* Seek from the end of p backwards to the first non-blank character.
   This is a bit difficult since array bounds must be kept in mind. */
inline char *rtrim(char *start, char *end)
{
    if ( !start ) return 0;
  /* Seek back to beginning or first non-blank */
  for (; end >start && (*end == 0 || isspace((int)(*end))); end--);
  /* Are we at the beginning? If so, we might either have a blank
     or a non-blank. */
  if ( end == start ) {
    if ( isspace((int)(*end)) )  *end=0;         /* \n or the like */
    else if ( *end != 0 ) *(end+1)=0;   /* non-empty string, zero next char */
  } else                *(end+1)=0;
  return end;
}



char *trim(char *start)
{
  register char *l;
  register char *end;

  if ( !start  || *start==0) return start;
  /* Find the end of the string */
  for (end=start; *end != 0; end++);
  end--;

  l=ltrim(start);
  end=rtrim(start,end);

  return l;
}

